package aplprolog.prolog.builtins;

import aplprolog.prolog.Prolog;

public interface ExternalTool {
	// @external(toolname,action(arg,arg2),R)) waar R lijst is bij 2 of meer, anders neemt het 't type van de return val aan, Prolog wacht op return
	// @external(toolname,action(arg,arg2)) succeeds altijd, prolog gaat gewoon verder
	// registerExternalAction(String actionname, ExternalTool tool, int callType, int returnType) callType = raw deepcopy of ints ; Object[], returnType same
	// handleCall(int[] call, Prolog p, int returnType) todo: maak Prolog.externalResult van type int[] en Object[]
	
	// nodig: toolname -> actionname -> [callType,returnType]
	// daarna: toolname -> tool ; tool.handleCall(deepcopy(call), bi.p, returnType)
	// daarna: if(returntype!=NONE && argcount = 3) transform return value, return unify R met de nieuwe value
	//         else: return true
	public String getName();
	public void handleCall(int[] call, ExternalActions p, int returnType);
	public void handleCall(Object[] call, ExternalActions p, int returnType);
	public void registerActions(Prolog p);
}
