package oopl.parsing;

import aplprolog.prolog.IntHarvester;

public class OoplToInts {
	PrologToInts pti;
	int imply_counter = 0;
	public boolean possiblyRegimented = false;
	
	public OoplToInts(PrologToInts pti){
		this.pti = pti;
	}
	
	public void deontic(int curSize, Token t){
		int start = curSize-1;
		if(t.image.equals("F(")) start = pti.array.pointer;
		pti.array.addInt(start,0);
		pti.array.addInt(start,pti.strID("false"));
		pti.array.addInt(start,IntHarvester.PREDICATE);
	}
	
	public void close_temporal(int start, int end){
		int x = pti.new_predicate("false"); //expiration
		
		x = pti.new_list(); // viol
		pti.array.intdata[x] = 1;
		x = pti.new_predicate("plus");
		pti.array.intdata[x] = 1;
		x = pti.new_predicate("viol");
		pti.array.intdata[x] = 1;
		for(int i = 0; i < end-start; i++)
			pti.array.addInt(pti.array.intdata[start+i]);
		pti.finish_list(x, 1);
		
		x = pti.new_list(); // obey
		pti.array.intdata[x] = 1;
		x = pti.new_predicate("plus");
		pti.array.intdata[x] = 1;
		x = pti.new_predicate("obey");
		pti.array.intdata[x] = 1;
		for(int i = 0; i < end-start; i++)
			pti.array.addInt(pti.array.intdata[start+i]);
		pti.finish_list(x, 1);
	}
	
	public void new_imply(){
		int x = pti.new_predicate("@scheme");
		pti.array.intdata[x] = 8;
		x = pti.new_predicate("@imply_rule"); // name
		pti.array.intdata[x] = 1;
		pti.new_num(new Token(0,""+imply_counter), 1);
		imply_counter++;
	}
	
	public void middle_imply(){
		pti.new_predicate("true");
		pti.new_predicate("false");
		pti.new_predicate("false");
		pti.new_predicate("false");
	}
	
	public void finish_imply(){
		int x = pti.new_list();
		pti.finish_list(x, 0);
		pti.fix_overhead();
		pti.add_rule();
	}
}
