package aplprolog.prolog.builtins;

import aplprolog.prolog.IntHarvester;

public class BuiltInTool {
	public BuiltInTool(){
		
	}
	public static void main(String[] args){
		BuiltInTool bit = new BuiltInTool();
		bit.create(); 
	}
	int counter = 0;
	String intercepts = "public static final int ";
	String interceptsStr = "String[] intercepts = new String[]{";
	String functions = "public static final int ";
	String functionsStr = "String[] functions = new String[]{";
	String arities = "public static final int[] arity = new int[]{";
	String execute = "public boolean execute(int[] call, boolean invar){\r\n"+
		"\tint id = call[1];\r\n"+
		"\tarithmetics.arithcursor = 3;\r\n"+
		"\tswitch(id){\r\n";
	
	
	public void create(){
		addI("=","UNIFY",2,"return (hasBeenCalled(call)?false:(unifycall(call,invar)?true:false))");
		addI("\\\\=","NOTUNIFY",2,"return (hasBeenCalled(call)?false:(unifycall(call,invar)?false:true))");
		
		addI("var","VAR",1,"return (hasBeenCalled(call)?false:(call[3]==IntHarvester.VARIABLE?p.substitution.value(call[4])==null:false))");
		addI("atom","ATOM",1,"return (hasBeenCalled(call)?false:atombuilding.isAtom(call,3,false))");
		addI("integer","INTEGER",1,"double d = arithmetics.evaluate(call);if(Double.isNaN(d)) return false;return arithmetics.isInt(d)");
		addI("float","FLOAT",1,"return (hasBeenCalled(call)?false:!Double.isNaN(arithmetics.evaluate(call)))");
		addI("atomic","ATOMIC",1,"return (hasBeenCalled(call)?false:(atombuilding.isAtom(call,3,false)||!Double.isNaN(arithmetics.evaluate(call))))");
		addI("compound","COMPOUND",1,"return (hasBeenCalled(call)?false:(!(atombuilding.isAtom(call,3,false)||!Double.isNaN(arithmetics.evaluate(call))) && !(call[3]==IntHarvester.VARIABLE?p.substitution.value(call[4])==null:false)))");
		addI("nonvar","NONVAR",1, "return (hasBeenCalled(call)?false:(call[3]==IntHarvester.VARIABLE?p.substitution.value(call[4])!=null:false))");
		addI("number","NUMBER",1,"return (hasBeenCalled(call)?false:!Double.isNaN(arithmetics.evaluate(call)))");

		addI("@=<","TERMEQLT",2,"return (hasBeenCalled(call)?false:compareTerm(call, id))");
		addI("==","TERMEQ",2,"return (hasBeenCalled(call)?false:compareTerm(call, id))");
		addI("\\\\==","TERMNEQ",2,"return (hasBeenCalled(call)?false:compareTerm(call, id))");
		addI("@<","TERMLT",2,"return (hasBeenCalled(call)?false:compareTerm(call, id))");
		addI("@>","TERMGT",2,"return (hasBeenCalled(call)?false:compareTerm(call, id))");
		addI("@>=","TERMGTEQ",2,"return (hasBeenCalled(call)?false:compareTerm(call, id))");
		
		addI("functor","FUNCTOR",3);
		addI("arg","ARG",3);
		addI("=..","DECOMPOSE",2);
		addI("copy_term","COPY_TERM",2);

		addI(" is ","IS",2,"return (hasBeenCalled(call)?false:arithmetics.arithmetic(call))");
		addI("=:=","ARITHEQ",2,"return (hasBeenCalled(call)?false:arithmetics.arithmeticEQ(call))");
		addI("=\\\\=","ARITHNEQ",2,"return (hasBeenCalled(call)?false:!arithmetics.arithmeticEQ(call))");
		addI("<","LT",2,"return (hasBeenCalled(call)?false:compareNum(call, id))");
		addI("=<","EQLT",2,"return (hasBeenCalled(call)?false:compareNum(call, id))");
		addI(">","GT",2,"return (hasBeenCalled(call)?false:compareNum(call, id))");
		addI(">=","GTEQ",2,"return (hasBeenCalled(call)?false:compareNum(call, id))");

		addI("clause","CLAUSE",2);
		addI("current_predicate","CURPRED",1);
		addI("asserta","ASSERTA",1,"return hasBeenCalled(call)?false:rulemods.queryAssert(call,true,false,false)");
		addI("assertz","ASSERTZ",1,"return hasBeenCalled(call)?false:rulemods.queryAssert(call,false,false,false)");
		addI("assert","ASSERT",1,"return hasBeenCalled(call)?false:rulemods.queryAssert(call,false,false,false)");
		addI("uniqueassertz","UNIQUEASSERTZ",1,"return hasBeenCalled(call)?false:rulemods.queryAssert(call,false,true,false)");
		addI("uniqueassertz2","UNIQUEASSERTZ2",1,"return hasBeenCalled(call)?false:rulemods.queryAssert(call,false,true,true)");
		addI("atomic_update","ATOMIC_UPDATE",3,"return hasBeenCalled(call)?false:rulemods.atomicUpdate(call)");
		addI("retract","RETRACT",1,"return hasBeenCalled(call)?false:rulemods.queryRetract(call,false)");
		addI("retractall","RETRACTALL",1,"return hasBeenCalled(call)?false:rulemods.queryRetract(call,true)");
		addI("abolish","ABOLISH",1);

		addI("findall","FINDALL",3,"return answersets.collect(IC_FINDALL,call)");
		addI("bagof","BAGOF",3,"return answersets.collect(IC_BAGOF,call)");
		addI("setof","SETOF",3,"return answersets.collect(IC_SETOF,call)");

		addI("once","ONCE",1);
		addI("repeat","REPEAT",0);

		addI("atom_length","ATOM_LENGTH",2);
		addI("atom_concat","ATOM_CONCAT",3,"return (hasBeenCalled(call)?false:atombuilding.concatAtom(call))");
		addI("sub_atom","SUB_ATOM",5);
		addI("atom_chars","ATOM_CHARS",2);
		addI("atom_codes","ATOM_CODES",2);
		addI("char_code","CHAR_CODE",2);
		addI("number_chars","NUMBER_CHARS",2);
		addI("number_codes","NUMBER_CODES",2);

		addI("random","RANDOM",1,"return (hasBeenCalled(call)?false:randomNum(call))");
		addI("true","TRUE",0,"return !hasBeenCalled(call)");
		addI("int_to_atom","INT_TO_ATOM",2,"return (hasBeenCalled(call)?false:atombuilding.intToAtom(call, 3))");
		addI("fail","FAIL",0); 
		addI("IC_BUILT_IN_COLLECTOR_DO_NOT_USE","BUILT_IN_COLLECTOR_DO_NOT_USE",2,"answersets.expandCollection(call); return false");
		addI("@external3","EXTERNAL",4,"return (hasBeenCalled(call)?false:externalCall(call))"); 
		addI("@external","EXTERNAL1",3,"return (hasBeenCalled(call)?false:external.call(call,true))"); 
		addI("@external2","EXTERNAL2",2,"return (hasBeenCalled(call)?false:external.call(call,false))");  
		
		addI("built_in_reset_stable_flag","RESETSTABLE",0,"p.rulesModified = false; return true"); 
		addI("built_in_is_stable","ISSTABLE",0,"return !p.rulesModified"); 
		
		addI(":-","RULEIMPLY",2); 
		counter = 0;

		addF("+","ADD");
		addF("-","SUBTRACT");
		addF("*","MULTIPLY");
		addF("/","DIVIDE");
		addF(" div ","INTDIVIDE");
		addF(" rem ","REMAINDER");
		addF(" mod ","MODULO"); 
		addF("abs","ABS");
		addF("sign","SIGN");
		addF("float_integer_part","INTEGERPART");
		addF("float_fractional_part","FRACPART");
		addF("float","FLOAT");
		addF("floor","FLOOR");
		addF("ceil","CEIL");
		addF("ceiling","CEILING");
		addF("truncate","TRUNCATE");
		addF("round","ROUND");

		addF("**","STARPOW");
		addF("^","POW");
		addF("sin","SIN");
		addF("cos","COS");
		addF("atan","ATAN");
		addF("exp","EXP");
		addF("log","LOG");
		addF("log10","LOG10");
		addF("sqrt","SQRT");
		addF(">>","SHIFTRIGHT");
		addF("<<","SHIFTLEFT");
		addF("/\\\\","AND");
		addF("\\\\/","OR");
		addF("\\\\","COMPLEMENT");
		

		addF("max","MAX");
		addF("min","MIN");
		addF("integer","INTEGER");
		addF(" xor ","XOR");
		addF("tan","TAN");
		addF("asin","ASIN");
		addF("acos","ACOS"); 
		addF("pi","PI");
		addF("e","E"); 
		
		addF("enqueued","ENQUEUED"); 
		addF("immediate","IMMEDIATE"); 
		
		intercepts = intercepts.substring(0,intercepts.length()-1);
		interceptsStr = interceptsStr.substring(0,interceptsStr.length()-1);
		functions = functions.substring(0,functions.length()-1);
		functionsStr = functionsStr.substring(0,functionsStr.length()-1);
		arities = arities.substring(0,arities.length()-1);
		intercepts += ";";
		interceptsStr += "};";
		functions += ";";
		functionsStr += "};";
		arities += "};";
		execute += "\t}\r\n";
		execute += "\tif(p.trace)System.out.println(\": \"+p.strStorage.getString(id)+\" not (yet) implemented\");\r\n";
		execute+= "\treturn false;\r\n"; 
		execute += "}\r\n";
		System.out.println("// interceptors (intercept resolution to execute a build in method)");
		System.out.println(intercepts);
		System.out.println(interceptsStr);
		System.out.println(arities);
		System.out.println("// functions");
		System.out.println(functions);
		System.out.println(functionsStr);
		System.out.println(execute);
	}

	public void addI(String a, String b, int i){
		addI(a,b,i,null);
	}
	public void addI(String a, String b, int i,String switchToDo){
		intercepts += "IC_"+b+"="+counter+",";
		interceptsStr += '"'+a +'"'+ ",";
		arities += i+",";
		execute += "\tcase IC_"+ b + ":\t"+ (b.length()<7?"\t":"")+ (switchToDo==null?"return false":switchToDo)+";\r\n";
		counter++;
	}
	
	public void addF(String a, String b){
		functions += b+"="+counter+",";
		functionsStr += '"'+a +'"'+ ","; 
		counter++;
	}
}
