package oopl.parsing;

import aplprolog.prolog.IntHarvester;

public class DooplToInts {
	PrologToInts pti;
	
	boolean in_pre_condition = false;
	
	public DooplToInts(PrologToInts pti){
		this.pti = pti;
	}
	
	public void shove_to_end(int start, int end){
		for(int i = 0; i < end-start; i++) pti.array.addInt(pti.array.intdata[start+i]);
		for(int i = 0; i < end-start; i++) pti.array.removeIntAt(start);
	}

	public void add_label(String name, boolean isVar){
		int x = pti.new_predicate(in_pre_condition?"@pre_lbl":"@lbl");
		pti.array.intdata[x] = 2;
		if(isVar)pti.handle_var(name);
		else pti.new_predicate(name);
	}

	public int new_update(){
		int x = pti.new_predicate("@update");
		pti.array.intdata[x] = 3;
		return pti.array.pointer;
	}
	
	public void new_norm(){
		int x = pti.new_predicate("@scheme");
		pti.array.intdata[x] = 8;
	}
	
	public void end_parenthesized(int curSize, int counter, String std){
		if(counter > 0) pti.replace(curSize, counter);
		else{
			pti.array.intdata[curSize-1] = IntHarvester.PREDICATE;
			pti.array.intdata[curSize] = pti.strID(std);
			pti.array.addInt(curSize+1, 0);
		}
	}
	
	public void wrap_literal(Token t){
		String name = null;
		if(t == null) name = "update";
		else if(t.image == "-") name = "min";
		else name = "plus";
		int x = pti.new_predicate(name);
		pti.array.intdata[x] = 1;
	}
	public void inPre(){ in_pre_condition = true; }
	public void outPre(){ in_pre_condition = false; }
}
